#include <stm32f4xx.h>
#include <stm32f4xx_gpio.h>
#include <stm32f4xx_rcc.h>

unsigned char lcd_X,lcd_Y;//	    

//			 
//	 
#define lcd_port				GPIOD
//	 
#define lcd_pin_SCLK		GPIO_Pin_12
#define lcd_pin_SDA			GPIO_Pin_13
#define lcd_pin_CS			GPIO_Pin_14
#define lcd_pin_RST			GPIO_Pin_15
//	  
#define lcd_RCC					RCC_AHB1Periph_GPIOD

//	     .
//	        
#define lcd_SCLK_on 	GPIO_SetBits(lcd_port, lcd_pin_SCLK);
#define lcd_SDA_on 		GPIO_SetBits(lcd_port, lcd_pin_SDA);
#define lcd_CS_on 		GPIO_SetBits(lcd_port, lcd_pin_CS);
#define lcd_RST_on 		GPIO_SetBits(lcd_port, lcd_pin_RST);
#define lcd_SCLK_off 	GPIO_ResetBits(lcd_port, lcd_pin_SCLK);
#define lcd_SDA_off 	GPIO_ResetBits(lcd_port, lcd_pin_SDA);
#define lcd_CS_off 		GPIO_ResetBits(lcd_port, lcd_pin_CS);
#define lcd_RST_off 	GPIO_ResetBits(lcd_port, lcd_pin_RST);
//************************************************************************//

//	     
#define lcd_CMD		0
#define lcd_DATA	1


void _delay_ms(uint32_t ms)
{
    volatile uint32_t nCount;
        RCC_ClocksTypeDef RCC_Clocks;
    RCC_GetClocksFreq (&RCC_Clocks);

        nCount=(RCC_Clocks.HCLK_Frequency/10000)*ms;
        for (; nCount!=0; nCount--);
}
void _delay_us(uint32_t us)
{
    volatile uint32_t nCount;
        RCC_ClocksTypeDef RCC_Clocks;
    RCC_GetClocksFreq (&RCC_Clocks);

        nCount=(RCC_Clocks.HCLK_Frequency/10000000)*us;
        for (; nCount!=0; nCount--);
}
//	
static const char lcd_font[][5] =
{
	{ 0x00, 0x00, 0x00, 0x00, 0x00 },  // sp
	{ 0x00, 0x00, 0x2f, 0x00, 0x00 },  // !
	{ 0x00, 0x07, 0x00, 0x07, 0x00 },  // "
	{ 0x14, 0x7f, 0x14, 0x7f, 0x14 },  // #
	{ 0x24, 0x2a, 0x7f, 0x2a, 0x12 },  // $
	{ 0x23, 0x13, 0x08, 0x64, 0x62 },  // %

	{ 0x36, 0x49, 0x55, 0x22, 0x50 },  // &
	{ 0x00, 0x05, 0x03, 0x00, 0x00 },  // '
	{ 0x00, 0x1c, 0x22, 0x41, 0x00 },  // (
	{ 0x00, 0x41, 0x22, 0x1c, 0x00 },  // )
	{ 0x14, 0x08, 0x3E, 0x08, 0x14 },  // *
	{ 0x08, 0x08, 0x3E, 0x08, 0x08 },  // +
	{ 0x00, 0x00, 0x50, 0x30, 0x00 },  // ,
	{ 0x10, 0x10, 0x10, 0x10, 0x10 },  // -
	{ 0x00, 0x60, 0x60, 0x00, 0x00 },  // .
	{ 0x20, 0x10, 0x08, 0x04, 0x02 },  // /
	{ 0x3E, 0x51, 0x49, 0x45, 0x3E },  // 0
	{ 0x00, 0x42, 0x7F, 0x40, 0x00 },  // 1
	{ 0x42, 0x61, 0x51, 0x49, 0x46 },  // 2
	{ 0x21, 0x41, 0x45, 0x4B, 0x31 },  // 3
	{ 0x18, 0x14, 0x12, 0x7F, 0x10 },  // 4
	{ 0x27, 0x45, 0x45, 0x45, 0x39 },  // 5
	{ 0x3C, 0x4A, 0x49, 0x49, 0x30 },  // 6
	{ 0x01, 0x71, 0x09, 0x05, 0x03 },  // 7
	{ 0x36, 0x49, 0x49, 0x49, 0x36 },  // 8
	{ 0x06, 0x49, 0x49, 0x29, 0x1E },  // 9
	{ 0x00, 0x36, 0x36, 0x00, 0x00 },  // :
	{ 0x00, 0x56, 0x36, 0x00, 0x00 },  // ;
	{ 0x08, 0x14, 0x22, 0x41, 0x00 },  // <
	{ 0x14, 0x14, 0x14, 0x14, 0x14 },  // =
	{ 0x00, 0x41, 0x22, 0x14, 0x08 },  // >
	{ 0x02, 0x01, 0x51, 0x09, 0x06 },  // ?
	{ 0x32, 0x49, 0x59, 0x51, 0x3E },  // @
	{ 0x7E, 0x11, 0x11, 0x11, 0x7E },  // A
	{ 0x7F, 0x49, 0x49, 0x49, 0x36 },  // B
	{ 0x3E, 0x41, 0x41, 0x41, 0x22 },  // C
	{ 0x7F, 0x41, 0x41, 0x22, 0x1C },  // D
	{ 0x7F, 0x49, 0x49, 0x49, 0x41 },  // E
	{ 0x7F, 0x09, 0x09, 0x09, 0x01 },  // F
	{ 0x3E, 0x41, 0x49, 0x49, 0x7A },  // G
	{ 0x7F, 0x08, 0x08, 0x08, 0x7F },  // H
	{ 0x00, 0x41, 0x7F, 0x41, 0x00 },  // I
	{ 0x20, 0x40, 0x41, 0x3F, 0x01 },  // J
	{ 0x7F, 0x08, 0x14, 0x22, 0x41 },  // K
	{ 0x7F, 0x40, 0x40, 0x40, 0x40 },  // L
	{ 0x7F, 0x02, 0x0C, 0x02, 0x7F },  // M
	{ 0x7F, 0x04, 0x08, 0x10, 0x7F },  // N
	{ 0x3E, 0x41, 0x41, 0x41, 0x3E },  // O
	{ 0x7F, 0x09, 0x09, 0x09, 0x06 },  // P
	{ 0x3E, 0x41, 0x51, 0x21, 0x5E },  // Q
	{ 0x7F, 0x09, 0x19, 0x29, 0x46 },  // R
	{ 0x46, 0x49, 0x49, 0x49, 0x31 },  // S
	{ 0x01, 0x01, 0x7F, 0x01, 0x01 },  // T
	{ 0x3F, 0x40, 0x40, 0x40, 0x3F },  // U
	{ 0x1F, 0x20, 0x40, 0x20, 0x1F },  // V
	{ 0x3F, 0x40, 0x38, 0x40, 0x3F },  // W
	{ 0x63, 0x14, 0x08, 0x14, 0x63 },  // X
	{ 0x07, 0x08, 0x70, 0x08, 0x07 },  // Y
	{ 0x61, 0x51, 0x49, 0x45, 0x43 },  // Z
	{ 0x00, 0x7F, 0x41, 0x41, 0x00 },  // [
	{ 0x55, 0x2A, 0x55, 0x2A, 0x55 },  // 55
	{ 0x00, 0x41, 0x41, 0x7F, 0x00 },  // ]
	{ 0x04, 0x02, 0x01, 0x02, 0x04 },  // ^
	{ 0x40, 0x40, 0x40, 0x40, 0x40 },  // _
	{ 0x00, 0x01, 0x02, 0x04, 0x00 },  // '
	{ 0x20, 0x54, 0x54, 0x54, 0x78 },  // a
	{ 0x7F, 0x48, 0x44, 0x44, 0x38 },  // b
	{ 0x38, 0x44, 0x44, 0x44, 0x20 },  // c
	{ 0x38, 0x44, 0x44, 0x48, 0x7F },  // d
	{ 0x38, 0x54, 0x54, 0x54, 0x18 },  // e
	{ 0x08, 0x7E, 0x09, 0x01, 0x02 },  // f
	{ 0x0C, 0x52, 0x52, 0x52, 0x3E },  // g
	{ 0x7F, 0x08, 0x04, 0x04, 0x78 },  // h
	{ 0x00, 0x44, 0x7D, 0x40, 0x00 },  // i
	{ 0x20, 0x40, 0x44, 0x3D, 0x00 },  // j
	{ 0x7F, 0x10, 0x28, 0x44, 0x00 },  // k
	{ 0x00, 0x41, 0x7F, 0x40, 0x00 },  // l
	{ 0x7C, 0x04, 0x18, 0x04, 0x78 },  // m
	{ 0x7C, 0x08, 0x04, 0x04, 0x78 },  // n
	{ 0x38, 0x44, 0x44, 0x44, 0x38 },  // o
	{ 0x7C, 0x14, 0x14, 0x14, 0x08 },  // p
	{ 0x08, 0x14, 0x14, 0x18, 0x7C },  // q
	{ 0x7C, 0x08, 0x04, 0x04, 0x08 },  // r
	{ 0x48, 0x54, 0x54, 0x54, 0x20 },  // s
	{ 0x04, 0x3F, 0x44, 0x40, 0x20 },  // t
	{ 0x3C, 0x40, 0x40, 0x20, 0x7C },  // u
	{ 0x1C, 0x20, 0x40, 0x20, 0x1C },  // v
	{ 0x3C, 0x40, 0x30, 0x40, 0x3C },  // w
	{ 0x44, 0x28, 0x10, 0x28, 0x44 },  // x
	{ 0x0C, 0x50, 0x50, 0x50, 0x3C },  // y
	{ 0x44, 0x64, 0x54, 0x4C, 0x44 },  // z

	{ 0x08, 0x08, 0x36, 0x41, 0x41 },  // {
	{ 0x00, 0x00, 0x7F, 0x00, 0x00 },  // |
	{ 0x41, 0x41, 0x36, 0x08, 0x08 },   // }
	{ 0x02, 0x01, 0x02, 0x02, 0x01 },   // ~

	{ 0x7E, 0x11, 0x11, 0x11, 0x7E },  // 
	{ 0x7F, 0x49, 0x49, 0x49, 0x33 },  // 
	{ 0x7F, 0x49, 0x49, 0x49, 0x36 },  // 
	{ 0x7F, 0x01, 0x01, 0x01, 0x03 },  // 
	{ 0xE0, 0x51, 0x4F, 0x41, 0xFF },  // 
	{ 0x7F, 0x49, 0x49, 0x49, 0x49 },  // 
	{ 0x77, 0x08, 0x7F, 0x08, 0x77 },  // 
	{ 0x49, 0x49, 0x49, 0x49, 0x36 },  // 
	{ 0x7F, 0x10, 0x08, 0x04, 0x7F },  // 
	{ 0x7C, 0x21, 0x12, 0x09, 0x7C },  // 
	{ 0x7F, 0x08, 0x14, 0x22, 0x41 },  // 
	{ 0x20, 0x41, 0x3F, 0x01, 0x7F },  // 
	{ 0x7F, 0x02, 0x0C, 0x02, 0x7F },  // 
	{ 0x7F, 0x08, 0x08, 0x08, 0x7F },  // 
	{ 0x3E, 0x41, 0x41, 0x41, 0x3E },  // 
	{ 0x7F, 0x01, 0x01, 0x01, 0x7F },  // 
	{ 0x7F, 0x09, 0x09, 0x09, 0x06 },  // 
	{ 0x3E, 0x41, 0x41, 0x41, 0x22 },  // 
	{ 0x01, 0x01, 0x7F, 0x01, 0x01 },  // 
	{ 0x27, 0x48, 0x48, 0x48, 0x3F },  // 
	{ 0x1C, 0x22, 0x7F, 0x22, 0x1C },  // 
	{ 0x63, 0x14, 0x08, 0x14, 0x63 },  // 
	{ 0x7F, 0x40, 0x40, 0x40, 0xFF },  // 
	{ 0x07, 0x08, 0x08, 0x08, 0x7F },  // 
	{ 0x7F, 0x40, 0x7F, 0x40, 0x7F },  // 
	{ 0x7F, 0x40, 0x7F, 0x40, 0xFF },  // 
	{ 0x01, 0x7F, 0x48, 0x48, 0x30 },  // 
	{ 0x7F, 0x48, 0x30, 0x00, 0x7F },  // 
	{ 0x7F, 0x48, 0x48, 0x30, 0x00 },  // 
	{ 0x22, 0x41, 0x49, 0x49, 0x3E },  // 
	{ 0x7F, 0x08, 0x3E, 0x41, 0x3E },  // 
	{ 0x46, 0x29, 0x19, 0x09, 0x7F },  // 
	{ 0x20, 0x54, 0x54, 0x54, 0x78 },  // 
	{ 0x3C, 0x4A, 0x4A, 0x49, 0x31 },  // 
	{ 0x7C, 0x54, 0x54, 0x28, 0x00 },  // 
	{ 0x7C, 0x04, 0x04, 0x04, 0x0C },  // 
	{ 0xE0, 0x54, 0x4C, 0x44, 0xFC },  // 
	{ 0x38, 0x54, 0x54, 0x54, 0x08 },  // 
	{ 0x6C, 0x10, 0x7C, 0x10, 0x6C },  // 
	{ 0x44, 0x44, 0x54, 0x54, 0x28 },  // 
	{ 0x7C, 0x20, 0x10, 0x08, 0x7C },  // 
	{ 0x78, 0x42, 0x24, 0x12, 0x78 },  // 
	{ 0x7C, 0x10, 0x28, 0x44, 0x00 },  // 
	{ 0x20, 0x44, 0x3C, 0x04, 0x7C },  // 
	{ 0x7C, 0x08, 0x10, 0x08, 0x7C },  // 
	{ 0x7C, 0x10, 0x10, 0x10, 0x7C },  // 
	{ 0x38, 0x44, 0x44, 0x44, 0x38 },  // 
	{ 0x7C, 0x04, 0x04, 0x04, 0x7C },  // 
	{ 0x7C, 0x14, 0x14, 0x14, 0x08 },  // 
	{ 0x38, 0x44, 0x44, 0x44, 0x44 },  // 
	{ 0x04, 0x04, 0x7C, 0x04, 0x04 },  // 
	{ 0x0C, 0x50, 0x50, 0x50, 0x3C },  // 
	{ 0x18, 0x24, 0x7E, 0x24, 0x18 },  // 
	{ 0x44, 0x28, 0x10, 0x28, 0x44 },  // 
	{ 0x7C, 0x40, 0x40, 0x40, 0xFC },  // 
	{ 0x0C, 0x10, 0x10, 0x10, 0x7C },  // 
	{ 0x7C, 0x40, 0x7C, 0x40, 0x7C },  // 
	{ 0x7C, 0x40, 0x7C, 0x40, 0xFC },  // 
	{ 0x04, 0x7C, 0x50, 0x50, 0x20 },  // 
	{ 0x7C, 0x50, 0x20, 0x00, 0x7C },  // 
	{ 0x7C, 0x50, 0x50, 0x20, 0x00 },  // 
	{ 0x28, 0x44, 0x54, 0x54, 0x38 },  // 
	{ 0x7C, 0x10, 0x38, 0x44, 0x38 },  // 
	{ 0x08, 0x54, 0x34, 0x14, 0x7C }  // 
};


//	   
void lcd_pin_init(void)
{
	GPIO_InitTypeDef lcd_GPIO_InitStructure;	//	    
	RCC_AHB1PeriphClockCmd(lcd_RCC, ENABLE);
	lcd_GPIO_InitStructure.GPIO_Pin = lcd_pin_SCLK | lcd_pin_SDA |lcd_pin_CS | lcd_pin_RST;
	lcd_GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;  // 
	GPIO_Init(lcd_port, &lcd_GPIO_InitStructure);
}

//	 
void lcd_clear(void)
{
	unsigned int i;
	lcd_write(lcd_CMD,0x40);// Y = 0
	lcd_write(lcd_CMD,0xb0);
	lcd_write(lcd_CMD,0x10);// X = 0
	lcd_write(lcd_CMD,0x00);
	lcd_write(lcd_CMD,0xae);// disable display;
	for(i=0;i<864;i++)
	lcd_write(lcd_DATA,0x00);
	lcd_write(lcd_CMD,0xaf);// enable display;
}


//	  
//	Input : cd -   ,  -    
void lcd_write(char cd,unsigned char c)
{
	char i;
	lcd_CS_off;
	lcd_SCLK_off;
	if(cd)
	{
		lcd_SDA_on;
	}
	else
	{
		lcd_SDA_off;
	}
	lcd_SCLK_on;
	for(i=0;i<8;i++)
	{
		lcd_SCLK_off;
		if(c & 0x80)
		{
			lcd_SDA_on;
		}
		else
		{
			lcd_SDA_off;
		}
		lcd_SCLK_on;
		c <<= 1;
		_delay_us(35); //Delay10TCYx(20);
	}
	lcd_CS_on;   //???
}

//	 
void lcd_init(void)
{
	lcd_CS_off;
	lcd_RST_off;
	_delay_ms(25);
	lcd_RST_on;
	_delay_ms(25);
/*	lcd_write(lcd_CMD,0xE2);
	_delay_ms(10);
	lcd_write(lcd_CMD,0xAF);
	lcd_write(lcd_CMD,0xA4);
	lcd_write(lcd_CMD,0x2F);
	lcd_write(lcd_CMD,0xB0);
	lcd_write(lcd_CMD,0x10);
	lcd_write(lcd_CMD,0x00);*/

	lcd_write(lcd_CMD,0x20);//- write VOP register
	lcd_write(lcd_CMD,0x90); //  0x90 0x9f
	lcd_write(lcd_CMD,0xA4);//- all on/normal display  A4/A5
	lcd_write(lcd_CMD,0x2F);//- Power control set(charge pump on/off)
	lcd_write(lcd_CMD,0x40);//- set start row address = 0
	lcd_write(lcd_CMD,0xb0);//- set Y-address = 0
	lcd_write(lcd_CMD,0x10);//- set X-address, upper 3 bits
	lcd_write(lcd_CMD,0x0);//- set X-address, lower 4 bits
//	lcd_write(lcd_CMD,0xC8);//- mirror Y axis (about X axis)
//	lcd_write(lcd_CMD,0xa1);// Invert screen in horizontal axis
	lcd_write(lcd_CMD,0xac);//- set initial row (R0) of the display
	lcd_write(lcd_CMD,0x07);
	lcd_write(lcd_CMD,0xaf); //- display ON/OFF

	lcd_clear();
//	lcd_write(lcd_CMD,0xa7); //- invert display
	lcd_write(lcd_CMD,0xa6);//- normal display (non inverted )
	_delay_ms(500);
}

//	 
// 	Input : x,y -  
void lcd_gotoxy(unsigned char x,unsigned char y)
{
	lcd_X=x;
	lcd_Y=y;
	x=x*6;
	lcd_write(lcd_CMD,(0xB0|(y&0x0F)));// Y axis initialisation: 0100 yyyy
	lcd_write(lcd_CMD,(0x00|(x&0x0F))); // X axis initialisation: 0000 xxxx ( x3 x2 x1 x0)
	lcd_write(lcd_CMD,(0x10|((x>>4)&0x07)));// X axis initialisation: 0010 0xxx  ( x6 x5 x4)
}
//	        
//	Input :  -   ASCII 
unsigned char lcd_symbol_decode(unsigned char c)
{
	if(32<=c&&c<='~')
	{
		c=c-32;
	}
	else
	{
		if(192<=c&&c<=255)
		{
			c=c-97;
		}
		else
		{
			c=255;
		}
	}
	return c;
}

//	   
//	Input :  -   ASCII 
void lcd_putch(unsigned char c)
{
	c=lcd_symbol_decode(c);
	if(c==255)
	{
		return;
	}
	lcd_write(lcd_DATA,lcd_font[c][0]);
	lcd_write(lcd_DATA,lcd_font[c][1]);
	lcd_write(lcd_DATA,lcd_font[c][2]);
	lcd_write(lcd_DATA,lcd_font[c][3]);
	lcd_write(lcd_DATA,lcd_font[c][4]);
	lcd_write(lcd_DATA,0x00);
	lcd_X++;
	if(lcd_X==16)
	{
		if(lcd_Y==7)
		{
			lcd_gotoxy(0,0);
		}
		else
		{
			lcd_gotoxy(0,lcd_Y+1);
		}
	}
}
void lcd_putch_inv(unsigned char c)
{
	c=lcd_symbol_decode(c);
	if(c==255)
	{
		return;
	}
	lcd_write(lcd_DATA,255-lcd_font[c][0]);
	lcd_write(lcd_DATA,255-lcd_font[c][1]);
	lcd_write(lcd_DATA,255-lcd_font[c][2]);
	lcd_write(lcd_DATA,255-lcd_font[c][3]);
	lcd_write(lcd_DATA,255-lcd_font[c][4]);
	lcd_write(lcd_DATA,255);
	lcd_X++;
	if(lcd_X==16)
	{
		if(lcd_Y==7)
		{
			lcd_gotoxy(0,0);
		}
		else
		{
			lcd_gotoxy(0,lcd_Y+1);
		}
	}
}
//	   
//	Input : s - 
void lcd_puts(const char *s)
{
	while (*s)
	{
		lcd_putch(*s);
		++s;
	}
}

void lcd_puts_inv(const char *s)
{
	while (*s)
	{
		lcd_putch_inv(*s);
		++s;
	}
}

//	    2,4,8 
//	Input : col - , row - , c -   ASCII
//	       2: 1,2,4,8
void lcd_putch_big(unsigned char col,unsigned char row,unsigned char c)
{
	unsigned char i,j,k,l,variable1,shift1,variable2,shift2,shift3,t_X,t_Y;
	unsigned int sym,sym2;
	t_X=lcd_X;
	t_Y=lcd_Y;
	c=lcd_symbol_decode(c);
	if(c==255)
	{
		return;
	}
	lcd_gotoxy(lcd_X,lcd_Y);
	variable1=0;
	shift1=8/row;
	variable2=1;
	switch(row)
	{
		case 1: {shift2=1; shift3=1; }break;
		case 2: {shift2=16;shift3=2; }break;
		case 4: {shift2=4; shift3=8; }break;
		case 8: {shift2=2; shift3=32;}break;
	}
	for(i=0;i<row;i++)
	{
		for(j=0;j<5;j++)
		{
			sym=0;
			l=1;
			for(k=variable1;k<variable1+shift1;k++)
			{
				sym+=(lcd_font[c][j]&(1<<k))*l;
				l*=shift3;
			}
			sym=sym/variable2;

			sym2=0;
			for(k=0;k<row;k++)
			{
				sym2=sym2+sym;
				sym*=2;
			}
			for(k=0;k<col;k++)
			{
				lcd_write(lcd_DATA,sym2);
			}
		}
		lcd_gotoxy(lcd_X,lcd_Y+1);
		variable1+=shift1;
		variable2*=shift2;
	}
	lcd_X=t_X+col;
	lcd_Y=t_Y;
}

//	    2,4,8 
//	Input : col - , row - , *s -   
//	       2: 1,2,4,8
void lcd_puts_big(unsigned char col,unsigned char row,unsigned char *s)
{
	while (*s)
	{
		lcd_putch_big(col,row,*s);
		++s;
	}

}

void char_5_8(char c, char x, char y)
{
	unsigned char i;
	lcd_gotoxy(x,y);
        	for ( i = 0; i < 5; i++ )
            {
				lcd_write(lcd_DATA,lcd_font[c+16][i] << 1);
            }
			lcd_write(lcd_DATA,0x00);

}
//	     
void lcd_test(void)
{
	unsigned char i;
  lcd_gotoxy(0,0);
	for(i=32;i<127;i++)
  {
		lcd_putch(i);
	}
	for(i=192;i<=224;i++)
  {
		lcd_putch(i);
	}
}

void nlcd_Inverse(unsigned char mode)
{
	if (mode) lcd_write(lcd_CMD,0xA6);
	 else lcd_write(lcd_CMD,0xA7);
}





int main(void)
{
	char rav=9;
	lcd_pin_init();
	lcd_init();
	lcd_puts_big(2,2,"LCD");
	lcd_gotoxy(7,0);
	lcd_puts("Nokia1202");
	lcd_gotoxy(10,1);
	lcd_puts("+STM32");
	lcd_gotoxy(2,3);
	lcd_puts("96x65 ");
	lcd_gotoxy(3,4);
	lcd_puts("8x16 ");
	lcd_gotoxy(2,5);
	lcd_puts("35x35 ");
	lcd_gotoxy(5,7);
	lcd_puts("steep_zero");
	_delay_ms(1500);
	nlcd_Inverse(0);
	_delay_ms(1500);
	nlcd_Inverse(1);
	lcd_test();
	_delay_ms(1500);
	nlcd_Inverse(0);
	_delay_ms(1510);
	nlcd_Inverse(1);
	lcd_clear();
	lcd_puts_big(8,8,"12");

	_delay_ms(1500);
	lcd_clear();

	lcd_puts_inv("ghbdtn");
	while(1)
    {

    }
}
